#!/usr/bin/perl

#$G{perlLib} = "/home/arimaa/web/arimaa/gameroom";
#$G{botGames} = "botGames";

#push(@INC, $G{perlLib});

chdir "gr";

require "cgi.pl";
require "html.pl";
#require "cookie.pl";
require "time.pl";
require "data.pl";

CgiPrintHeader();
%in = CgiGetVars();
#print "<pre>\n";

#%c = &CookieRead();

$year = 2005; # Year in which to look for top human player games
@bots = ('bot_Bomb2005CC', 'bot_Clueless2005CC', 'bot_GnoBot2005CC', 'bot_Loc2005CC');

$startdate = "1/1/$year";
$year += 1;
$enddate = "1/1/$year";

$startdatets = `/bin/date -d '$startdate GMT' +"%s"`;
$enddatets = `/bin/date -d '$enddate GMT' +"%s"`;
chomp($startdatets);
chomp($enddatets);


foreach $bot (@bots){
  $selectedBots .= "wusername='$bot' or ";
  $selectedBots .= "busername='$bot' or ";
}
$selectedBots =~ s/or $//;

%g = DataGetPastGameRec("rated=1 and startts>$startdatets and endts<$enddatets and ($selectedBots) and (wtype='h' or btype='h') order by endts");


################################################
# If looking for specific games, process them here
################################################
$in{p} =~ s/\W//g;
$in{b} =~ s/\W//g;
if ($in{p} ne ""){
#  if ($in{b} ne ""){ $bo = $bots[$in{b}-1]; $b = lc($bo); }
  if ($in{b} ne ""){ $bo = $in{b}; $b = lc($bo); }
  while($g{id}){
    if (lc($g{wusername}) eq lc($in{p})){ goto keepGame; }
    if (lc($g{busername}) eq lc($in{p})){ goto keepGame; }
    %g = &DataGetNextRec();
    next;
keepGame:
    if ($b ne ""){
      if (lc($g{wusername}) eq $b){ goto keepGame2; }
      if (lc($g{busername}) eq $b){ goto keepGame2; }
      %g = &DataGetNextRec();
      next;
    }
keepGame2:
#    print "$g{wusername} vs $g{busername}\n";

###########
# build the game rows
    $wplayer = $g{wusername};
    $wplayer = qq(<a href="javascript:playerPage($g{wplayerid})"><b>$g{wusername}</b></a>);
    if ($g{wplayerid} != $in{id}){
#    $wplayer = qq(<a href="?id=$g{wplayerid}">$g{wusername}</a>);
      $wplayer = qq(<a href="javascript:playerPage($g{wplayerid})">$g{wusername}</a>);
    }
    $bplayer = $g{busername};
    $bplayer = qq(<a href="javascript:playerPage($g{bplayerid})"><b>$g{busername}</b></a>);
    if ($g{bplayerid} != $in{id}){
#    $bplayer = qq(<a href="?id=$g{bplayerid}">$g{busername}</a>);
      $bplayer = qq(<a href="javascript:playerPage($g{bplayerid})">$g{busername}</a>);
  }
#  $timecontrol = &makeTimeControlString($g{tcm}, $g{tcr}, $g{tcp}, $g{tcg});
    $timecontrol = $g{timecontrol};
    $rated = $g{rated}?"<b>R</b>":'';

    $wwins = "*";
    $bwins = "*";
    if ($g{result} eq "w"){ $bwins = ""; }
    if ($g{result} eq "b"){ $wwins = ""; }
    if ($g{result} eq "d"){ $wwins = "="; $bwins = "="; }

    $playedWhen = &getWhen($g{endts} - $r{timezone});


    $comments = qq(<a href="/arimaa/gameroom/comments.cgi?gid=$g{id}" target=_blank>add</a>);
    if ($g{commcount} > 0){
      $comments = qq(<a href="/arimaa/gameroom/comments.cgi?gid=$g{id}" target=_blank>$g{commcount} $g{commusername}</a>);
    }

    $myGameRows .= <<EOM;
<tr>
  <td align=right>
    $wwins $wplayer
<br>$g{wrating} &nbsp; $g{wcountry}
  </td>
  <td align=center>
    <font size=1>$rated $timecontrol</font><br>
<table background="/arimaa/graphics/BoardWithPiecesIcon2.jpg" width=50 height=50 border=0 cellspacing=0 cellpadding=0>
  <tr>
    <td >
<a href="replayFlash.cgi?gid=$g{id}&s=w" target=replay$g{id} >
  <img src="/arimaa/graphics/animals/blank.gif" width=25 height=49 border=0>
</a>
    </td>
    <td >
<a href="replayFlash.cgi?gid=$g{id}&s=b" target=replay$g{id}>
  <img src="/arimaa/graphics/animals/blank.gif" width=25 height=49 border=0>
</a>
    </td>
  </tr>
</table>
  </td>
  <td align=left>
    $bplayer $bwins
<br>$g{bcountry} &nbsp; $g{brating}
  </td>
  <td align=right>
    &nbsp; &nbsp;
  </td>
  <td align=center>
    $g{termination}
  </td>
  <td align=right>
    $g{plycount}
  </td>
  <td align=right>
    &nbsp; &nbsp;
  </td>
  <td align=left>
    $playedWhen GMT
  </td>
  <td align=right>
    &nbsp; &nbsp;
  </td>
  <td align=left>
    $comments
  </td>
</tr>
EOM


    %g = &DataGetNextRec();
  }

  if ($myGameRows){
    $myGames = <<EOM;
<table border=0>
  <tr> 
    <td colspan=3 align=center>
<b> 
<font size=-2>
Click on the board to view the game
</font>
</b>
    </td>
  </tr>
  <tr>
    <td align=right>
      Gold
    </td>
    <td align=center>
      &nbsp;
    </td>
    <td align=left>
      Silver
    </td>
    <td align=left>
    </td>

    <td align=left>
      <a href="javascript:reasonCodes();">Reason</a>
    </td>

    <td align=left>
      Moves
    </td>

    <td align=left>
    </td>
    <td align=left>
      Finished on
    </td>

    <td align=left>
    </td>
    <td align=left>
      Comments
    </td>
  </tr>
  $myGameRows
</table>
EOM
  }
  else{ print "no games found\n"; exit; }

print "</pre>\n";

$body = <<EOM;

<table border=0>
  <tr>
    <td valign=top align=center>
<p>
$myGames
    </td>

  </tr>
</table>

EOM

  print <<EOM;
<html>
  <head>
    <title>Selected Games for $in{p}</title>
    <base href="/arimaa/gameroom/" />

    <script language="JavaScript1.2">
<!--
function playerPage(id){
//  open('playerpage.cgi?id='+id,'','toolbar=no,width=650,height=450,scrollbars=no,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
  window.location = '/arimaa/gameroom/playerpage.cgi?id='+id;
  void('');
}

function reasonCodes(){
  open('reasonCodes.html','','toolbar=no,width=650,height=450,scrollbars=no,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
}
// -->
    </script>

  </head>

  <body bgcolor="#d8d8f8" >
<center>
  <h2 align=center>Selected Games for $in{p}</h2>
<center>
  <hr width=50%>
</center>
  <p>
  $body
</center>
  </body>
</html>

EOM

  exit;
}


##############################################
# Show the current standings
##############################################

while($g{id}){
  $bot = 'w';
  $hum = 'b';
  if ($g{wtype} eq 'h'){
    $bot = 'b';
    $hum = 'w';
  }

# if the game was resigned in less than 6 moves don't count it.
  if (($g{termination} eq 'r') && ($g{plycount} < 6)){
    goto skipIt;
  }

  $botn = lc($g{"${bot}username"});
  $humn = lc($g{"${hum}username"});

  $rt{"$humn$botn"} += 1;
  $rt{"$humn"} += 1;
  $rn{$humn} = 1;
  $rno{$humn} = $g{"${hum}username"};
  if ($g{result} eq $hum){
    $rw{"$humn$botn"} += 1;
#print qq(   human won $rw{"$humn$botn"}\n);
    $rm{"$humn$botn"} += $g{plycount};
    $rw{"$humn"} += 1;
    $rm{"$humn"} += $g{plycount};
  }
  if ($g{result} eq $bot){
    $rl{"$humn$botn"} += 1;
    $rl{"$humn"} += 1;
  }
  

#if ($humn eq 'pmertens'){
#  print "$g{wusername} vs $g{busername}  $g{result}\n";
#}



skipIt:
  %g = &DataGetNextRec();

}



while(($n,$v)=each(%rn)){
  if ($v < 0){ next; }

  my($d);
  if ($rw{$n} eq ""){ $rw{$n} = 0; }
  if ($rm{$n} eq ""){ $rm{$n} = 0; }
#print "$n $rw{$n}/$rt{$n}  $rm{$n}:$rw{$n}\n";
  $lw = 9999;
  foreach $bo (@bots){
    $b = lc($bo);
    if ($rw{"$n$b"}<0){ next; }
    $wa = "-";
    if ($rt{"$n$b"}>0){
      $wa = $rw{"$n$b"}/$rt{"$n$b"};
    }
    if ($rw{"$n$b"}<$lw){ $lw = $rw{"$n$b"}; }
  }
  if ($lw == 9999){ $lw = 0; }
  $adw = 0;
  $bi = 1;
  $awa = 0;
  foreach $bo (@bots){
    $b = lc($bo);
    $k = $n . lc($bo);
    if ($rw{$k} > $lw){ $adw += 1; }
#print " for $n - $b   = " . $rw{$k} . "\n";
    $aw = 0.0;
    if ($rt{$k} > 0){ $aw = 100*($rw{$k}-$rl{$k})/$rt{$k}; }
    $awa += $aw;
    $d->{"bot$bi"} = sprintf("(%01d-%01d)/%01d %.1f",  $rw{$k}, $rl{$k}, $rt{$k}, $aw);
    $d->{$bo} = sprintf("(%01d-%01d)/%01d %.1f",  $rw{$k}, $rl{$k}, $rt{$k}, $aw);
    $bi += 1;
  }
  $awa = $awa/($#bots+1);
#  $awa = ($rw{$n}-$rl{$n})/$rt{$n};
  $amg = 0;
  if ($rw{$n}>0){
    $amg = $rm{$n}/$rw{$n};
  }
  $d->{n} = $rno{$n};
  $d->{sc} = sprintf("%.1f", $awa*($lw + $adw/4));
  if (($lw+$adw) <= 0){
    $d->{sc} = "0.0";
  }
  $d->{sort} = sprintf("%08d%08d", 1000*$d->{sc}, 9999999-100*$amg);

  $d->{lw} = $lw;
  $d->{awa} = sprintf("%.1f", $awa);
  $d->{adw} = $adw;
  $d->{efw} = $lw + $adw/4;
  $d->{amg} = sprintf("%.1f", $amg);
  push(@d, $d);
}

@d = sort {$b->{sort} <=> $a->{sort}} @d;

foreach $d (@d){
  $botcol = "";
  $botnames = "";
  foreach $bot (@bots){
    $botcol .= <<EOM;
  <td align=center><a href="?p=$d->{n}&b=$bot">$d->{"$bot"}</a></td>
EOM
    $botnames .= <<EOM;
    <td align=center><b>$bot</b></td>
EOM
  }

  $rows .= <<EOM;

<tr>
  <td ><a href="?p=$d->{n}">$d->{n}</a></td>
$botcol
  <td align=center>$d->{efw}</td>
  <td align=center>$d->{awa}</td>
  <td align=center>$d->{sc}</td>
  <td align=center>$d->{amg}</td>
</tr>

EOM
}

if ($rows){
  $stats = <<EOM;
<p>$topClose
<table border=1>
  <tr>
    <td align=right><b>Username</b></td>
$botnames
    <td align=center><b>Effective Wins</b></td>
    <td align=center><b>Avg Win-Lose Pct</b></td>
    <td align=center><b>Score</b></td>
    <td align=center><b>Avg Moves</b></td>
<!--
    <td align=center><b>Most Recent Game</b></td>
    <td width=30%><b>Against</b></td>
    <td width=100><b>Against</b></td>
-->
  </tr>
  $rows
</table>

EOM
}
else{
  $stats = "No players have qualified yet\n";
}


print "</pre>\n";

print <<EOM;
<html>
  <head>
    <title>Top Human Players for the $year Arimaa Challenge</title>
    <script language="JavaScript1.2">
<!--
function playerPage(id){
    open('/arimaa/gameroom/playerpage.cgi?id='+id,'','toolbar=no,width=650,height=450,scrollbars=no,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
    void('');
}

function gamePage(id){
    open('/arimaa/gameroom/comments.cgi?gid='+id,'','');
    void('');
}

function openGame(id, role, side){
    open('/arimaa/gameroom/opengamewin.cgi?gameid='+id+'&role='+role+'&side='+side,'','toolbar=no,width=350,height=250,scrollbars=no,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
    void('');
}


// -->
    </script>
  </head>
  <body bgcolor="#d8d8f8">
<center>
<h3>Top Human Players for the $year Arimaa Challenge</h3>

<p>$stats

<p>
<table width=80%>
<tr>
  <td align=right valign=top>Score =</td><td>Effective Wins * Avg Win-Lose Pct</td>
</tr>
<tr>
  <td align=right valign=top>Effective Wins =</td>
  <td>Lowest number of games won against any one program 
<br>
+ a quarter point for any number of additional games won against 
each program
  </td>
</tr>
<tr>
  <td align=right valign=top><nobr>Avg Winning Pct =</nobr></td>
  <td>Average of the Winning Pct against each of the programs</td>
</tr>
<tr>
  <td align=right valign=top><nobr>Winning Pct =</nobr></td>
  <td>100 * (Wins - Loses) / Total Games</td>
</tr>
</table>


</center>
  </body>
</html>
EOM






exit;


